Subject: [RFC] adp1653: Add device tree bindings for LED controller

From: [email-masked] (Pavel Machek)
Date: Tue, 18 Nov 2014 17:51:48 +0100

Hi!

> >If the hardware LED changes with one that needs different current, the
> >block for the adp1653 stays the same, but white LED block should be
> >updated with different value.
> 
> I think that you are talking about sub nodes. Indeed I am leaning
> towards this type of design.

I think I am :-).

> >>I agree that flash-timeout should be per led - an array, similarly
> >>as in case of iout's.
> >
> >Agreed about per-led, disagreed about the array. As all the fields
> >would need arrays, and as LED system currently does not use arrays for
> >label and linux,default-trigger, I believe we should follow existing
> >design and model it as three devices. (It _is_ physically three devices.)
> 
> Right, I missed that the leds/common.txt describes child node.
> 
> I propose following modifications to the binding:
> 
> Optional properties for child nodes:
> - iout-mode-led : 	maximum intensity in microamperes of the LED
> 		  	(torch LED for flash devices)
> - iout-mode-flash : 	initial intensity in microamperes of the
> 			flash LED; it is required to enable support
> 			for the flash led
> - iout-mode-indicator : initial intensity in microamperes of the
> 			indicator LED; it is required to enable support
> 			for the indicator led
> - max-iout-mode-led : 	maximum intensity in microamperes of the LED
> 		  	(torch LED for flash devices)
> - max-iout-mode-flash : maximum intensity in microamperes of the
> 			flash LED
> - max-iout-mode-indicator : maximum intensity in microamperes of the
> 			indicator LED
> - flash-timeout :	timeout in microseconds after which flash
> 			led is turned off

Ok, I took a look, and "iout" is notation I understand, but people may
have trouble with and I don't see it used anywhere else.

Also... do we need both "current" and "max-current" properties?

But regulators already have "regulator-max-microamp" property. So what
about:

max-microamp : 	maximum intensity in microamperes of the LED
 		  	(torch LED for flash devices)
max-flash-microamp : 	initial intensity in microamperes of the
 			flash LED; it is required to enable support
 			for the flash led
flash-timeout-microseconds : timeout in microseconds after which flash
 			led is turned off

If you had indicator on the same led, I guess

indicator-microamp : recommended intensity in microamperes of the LED
		         for indication

...would do?

> I propose to avoid name "torch", as for ordinary leds it would
> be misleading.

Agreed.

Thanks,
									Pavel
-- 
(english) http://www.livejournal.com/~pavelmachek
(cesky, pictures) http://atrey.karlin.mff.cuni.cz/~pavel/picture/horses/blog.html